> ## Documentation Index
> Fetch the complete documentation index at: https://developers.hubspot.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Migrate CRM card views

> Swaps a Legacy CRM Card with an App Card in views. Reference the "Migrate a legacy CRM card to an app card" docs for more information

> [accordion] Supported products


## OpenAPI

````yaml specs/2026-09/crm-public-app-crm-cards-v2026-09.json POST /crm/extensions/cards-dev/2026-09/{appId}/views/migrate
openapi: 3.0.1
info:
  title: Public App Crm Cards
  description: Basepom for all HubSpot Projects
  version: 2026-09
  x-hubspot-product-tier-requirements:
    marketing: FREE
    sales: FREE
    service: FREE
    cms: FREE
    commerce: FREE
    crmHub: FREE
    dataHub: FREE
  x-hubspot-api-use-case: >-
    Add a custom card to contact records that displays data from your external
    bug tracking software.
  x-hubspot-introduction: >-
    Create custom cards to data from external systems on CRM records. Requires a
    public public app. These CRM cards are different from the UI extensions you
    can create with projects.
servers:
  - url: https://api.hubapi.com
security: []
tags:
  - name: Advanced
  - name: Basic
paths:
  /crm/extensions/cards-dev/2026-09/{appId}/views/migrate:
    post:
      tags:
        - Advanced
      summary: Migrate Card Views
      description: >-
        Swaps a Legacy CRM Card with an App Card in views. Reference the
        "Migrate a legacy CRM card to an app card" docs for more information
      operationId: >-
        post-/crm/extensions/cards-dev/2026-09/{appId}/views/migrate_/crm/v3/extensions/cards-dev/{appId}/views/migrate
      parameters:
        - name: appId
          in: path
          description: The unique identifier of the app for which views are being migrated.
          required: true
          style: simple
          explode: false
          schema:
            type: integer
            format: int32
      requestBody:
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/CardMigrateViewsRequest'
        required: true
      responses:
        '200':
          description: successful operation
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/CardMigrateViewsResponse'
        default:
          $ref: '#/components/responses/Error'
          description: ''
      security:
        - developer_hapikey: []
components:
  schemas:
    CardMigrateViewsRequest:
      required:
        - allowDuplicateAppCardIds
        - appCardId
        - legacyCrmCardId
      type: object
      properties:
        allowDuplicateAppCardIds:
          type: boolean
          description: >-
            A boolean flag indicating whether duplicate app card IDs are allowed
            during the migration process.
        appCardId:
          type: integer
          description: >-
            The unique identifier for the new app card to which views will be
            migrated. This is an integer in int64 format.
          format: int64
        helpdeskAppCardId:
          type: integer
          description: >-
            The unique identifier for the helpdesk app card, if applicable. This
            is an integer in int64 format.
          format: int64
        legacyCrmCardId:
          type: integer
          description: >-
            The unique identifier for the legacy CRM card. This is an integer in
            int64 format.
          format: int64
        tabAppCardId:
          type: integer
          format: int64
    CardMigrateViewsResponse:
      required:
        - message
      type: object
      properties:
        endedAt:
          type: integer
          description: The timestamp for when the migration ended.
          format: int64
        message:
          type: string
          description: A human readable message describing the progress of the migration.
        remainingPortalCount:
          type: integer
          description: >-
            The number of portals that remain to be swapped from the Legacy CRM
            Card to the App Card
          format: int64
        startedAt:
          type: integer
          description: The timestamp for when the migration started.
          format: int64
        totalPortalCount:
          type: integer
          description: The total number of portals that have access to the Legacy CRM Card
          format: int64
    Error:
      required:
        - category
        - correlationId
        - message
      type: object
      properties:
        category:
          type: string
          description: The error category
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: Context about the error condition
          example: >-
            {invalidPropertyName=[propertyValue], missingScopes=[scope1,
            scope2]}
        correlationId:
          type: string
          description: >-
            A unique identifier for the request. Include this value with any
            error reports or support tickets
          format: uuid
          example: aeb5f871-7f07-4993-9211-075dc63e7cbf
        errors:
          type: array
          description: further information about the error
          items:
            $ref: '#/components/schemas/ErrorDetail'
        links:
          type: object
          additionalProperties:
            type: string
          description: >-
            A map of link names to associated URIs containing documentation
            about the error or recommended remediation steps
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate
          example: An error occurred
        subCategory:
          type: string
          description: >-
            A specific category that contains more specific detail about the
            error
      description: >-
        Represents an error response returned by the API when an operation
        fails. This component is used in various endpoints to provide detailed
        information about the error encountered.
      example:
        message: Invalid input (details will vary based on the error)
        correlationId: aeb5f871-7f07-4993-9211-075dc63e7cbf
        category: VALIDATION_ERROR
        links:
          knowledge-base: https://www.hubspot.com/products/service/knowledge-base
    ErrorDetail:
      required:
        - message
      type: object
      properties:
        code:
          type: string
          description: The status code associated with the error detail
        context:
          type: object
          additionalProperties:
            type: array
            items:
              type: string
          description: Context about the error condition
          example: '{missingScopes=[scope1, scope2]}'
        in:
          type: string
          description: The name of the field or parameter in which the error was found.
        message:
          type: string
          description: >-
            A human readable message describing the error along with remediation
            steps where appropriate
        subCategory:
          type: string
          description: >-
            A specific category that contains more specific detail about the
            error
      description: >-
        Represents detailed information about an error that occurred in the API.
        This component is used to provide additional context and specifics about
        errors, typically as part of an error response.
  responses:
    Error:
      description: An error occurred.
      content:
        '*/*':
          schema:
            $ref: '#/components/schemas/Error'
  securitySchemes:
    developer_hapikey:
      type: apiKey
      name: hapikey
      in: query

````